;Program compiled by Great Cow BASIC (0.9 11/5/2014)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _MCLRE_ON & _CP_OFF & _CPD_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	32
DELAYTEMP2	EQU	33
SysBYTETempA	EQU	37
SysBYTETempB	EQU	41
SysBYTETempX	EQU	32
SysDivLoop	EQU	36
SysWaitTemp10US	EQU	37
SysWaitTempMS	EQU	34
SysWaitTempMS_H	EQU	35
ADREADPORT	EQU	38
ADTEMP	EQU	39
CONTADOR	EQU	40
CONTROL	EQU	42
LECTURA	EQU	43
READAD	EQU	44
REPETIR	EQU	45
SysTemp1	EQU	46
TEMPO	EQU	47

;********************************************************************************

;Alias variables
ALLANSEL	EQU	159

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Programa para un arranque estrella- triangulo
;el boton de parada es el MCLR (pin 4)
;el temporizado se regula mediante la entrada analogica (Pin 7)
;Chip Settings
;configuracin de puertos
;DIR GPIO b'00001011'
	movlw	11
	banksel	TRISIO
	movwf	TRISIO
;definicion de puertos y variables
;#DEFINE LINEA GP2
;#DEFINE ESTRELLA GP5
;#DEFINE TRIANGULO GP4
;#DEFINE MARCHA GP1
;DIM LECTURA AS BYTE
;DIM TEMPO AS BYTE
;DIM CONTADOR AS BYTE
;DIM REPETIR AS BYTE
;programa principal
;LINEA = 0 ;inicializacion
	banksel	GPIO
	bcf	GPIO,GP2
;ESTRELLA = 0
	bcf	GPIO,GP5
;TRIANGULO = 0
	bcf	GPIO,GP4
;CONTROL = 0
	clrf	CONTROL
;wait 200 ms
	movlw	200
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
PUNTO
;TEMPO = 0
	clrf	TEMPO
;For REPETIR = 1 TO 3
	clrf	REPETIR
SysForLoop1
	incf	REPETIR,F
;LECTURA = ReadAD (AN0) ;lectura del canal ad
	clrf	ADREADPORT
	call	FN_READAD
	movf	READAD,W
	movwf	LECTURA
;TEMPO =  TEMPO + (LECTURA / 3)
	movwf	SysBYTETempA
	movlw	3
	movwf	SysBYTETempB
	call	SysDivSub
	movf	SysBYTETempA,W
	movwf	SysTemp1
	addwf	TEMPO,F
;NEXT
	movlw	3
	subwf	REPETIR,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;REPETIR = TEMPO /4
	movf	TEMPO,W
	movwf	SysBYTETempA
	movlw	4
	movwf	SysBYTETempB
	call	SysDivSub
	movf	SysBYTETempA,W
	movwf	REPETIR
;IF CONTROL = 0 THEN
	movf	CONTROL,F
	btfss	STATUS, Z
	goto	ENDIF2
;IF MARCHA = 1 THEN
	btfss	GPIO,GP1
	goto	ENDIF3
;CONTROL = 1
	movlw	1
	movwf	CONTROL
;LINEA = 1
	bsf	GPIO,GP2
;ESTRELLA = 1
	bsf	GPIO,GP5
;FOR CONTADOR = 0 TO REPETIR STEP 1
	movlw	255
	movwf	CONTADOR
	movlw	0
	subwf	REPETIR,W
	btfss	STATUS, C
	goto	SysForLoopEnd2
SysForLoop2
	incf	CONTADOR,F
;WAIT 500 MS
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;NEXT
	movf	REPETIR,W
	subwf	CONTADOR,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;ESTRELLA = 0
	bcf	GPIO,GP5
;WAIT 200 MS
	movlw	200
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;TRIANGULO = 1
	bsf	GPIO,GP4
;END IF
ENDIF3
;END IF
ENDIF2
;Goto punto; volver a la direccin de salto
	goto	PUNTO
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	2
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	142
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	1
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD
;Perform conversion
;LLReadAD 1
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S1
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;Write output
;ReadAD = ADRESH
	banksel	ADRESH
	movf	ADRESH,W
	movwf	READAD
	return

;********************************************************************************

SYSDIVSUB
;dim SysByteTempA as byte
;dim SysByteTempB as byte
;dim SysByteTempX as byte
;SysByteTempX = 0
	clrf	SYSBYTETEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysByteTempA, F
	rlf	SYSBYTETEMPA, F
;rlf SysByteTempX, F
	rlf	SYSBYTETEMPX, F
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W
;subwf SysByteTempX, F
	subwf	SYSBYTETEMPX, F
;bsf SysByteTempA, 0
	bsf	SYSBYTETEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysByteTempA, 0
	bcf	SYSBYTETEMPA, 0
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W
;addwf SysByteTempX, F
	addwf	SYSBYTETEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************


 END
