;------------------------------------------------------------
; Cdigo assembler generado por Niple V5.6.4
; Proyecto: DY1
; Autor: JUAN DIEGO FLORES
; Fecha: 11/06/2015
; PIC: 12F675
; Velocidad de reloj: Int 4 Mhz
; Descripcion: 
;------------------------------------------------------------


 LIST    P=PIC12F675


_INTRC_OSC_NOCLKOUT   equ  0x3FFC
_WDT_OFF              equ  0x3FF7
_PWRTE_ON             equ  0x3FEF
_MCLRE_ON             equ  0x3FFF
_BODEN_OFF            equ  0x3FBF
_CPD_OFF              equ  0x3FFF
_CP_OFF               equ  0x3FFF

 __config _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_ON & _MCLRE_ON & _BODEN_OFF & _CPD_OFF & _CP_OFF


;------------------------------------------------------------
;                  Declaracin de Registros
;------------------------------------------------------------
w                     equ  0x0000
status                equ  0x0003
gpio                  equ  0x0005
pclath                equ  0x000a
cmcon                 equ  0x0019
adresh                equ  0x001e
adcon0                equ  0x001f
lectura               equ  0x0021
_np_temp1             equ  0x0022
_np_temp2             equ  0x0023
_np_temp3             equ  0x0024
_np_temp4             equ  0x0025
_np_temp5             equ  0x0026
repetir               equ  0x0027
_np_temp6             equ  0x0028
_np_temp7             equ  0x0029
control               equ  0x002c
_np_tiempo            equ  0x002d
_np_veces             equ  0x002e
_np_tiempo1           equ  0x002f
_np_tiempo2           equ  0x0030
_np_tiempo3           equ  0x0031
repetir2              equ  0x0032
_np_tmp_var1          equ  0x0036
_np_temp8             equ  0x0037
_np_temp9             equ  0x0038
_np_temp10            equ  0x0039
_np_temp11            equ  0x003a
_np_temp12            equ  0x003b
_np_temp13            equ  0x003c
_np_temp14            equ  0x003d
_np_temp15            equ  0x003e
_np_temp16            equ  0x003f
trisio                equ  0x0085
ansel                 equ  0x009f


;------------------------------------------------------------
;                  Declaracin de Bits
;------------------------------------------------------------
adfm                  equ  7   ;
adon                  equ  0   ;
c                     equ  0   ;carry / borrow bit
go_done               equ  1   ;
gp1                   equ  1   ;bit 1 del puerto
gp2                   equ  2   ;bit 2 del puerto
gp4                   equ  4   ;bit 4 del puerto
gp5                   equ  5   ;bit 5 del puerto
rp0                   equ  5   ;registrer bank select bit
rp1                   equ  6   ;registrer bank select bit
z                     equ  2   ;bit cero


;------------------------------------------------------------
;               Declaracin de Registros EEPROM
;------------------------------------------------------------


;------------------------------------------------------------
;                        Inicio
;------------------------------------------------------------

   org 0x00
   goto paso2


;------------------------------------------------------------
;                      programa principal
;------------------------------------------------------------
paso2
   bcf status,rp0                   ;cambiar a banco 0
   clrf lectura
   clrf _np_temp1
   clrf _np_temp2
   clrf _np_temp3
   clrf _np_temp4
   clrf _np_temp5
   clrf repetir
   clrf _np_temp6
   clrf _np_temp7
   clrf control
   clrf _np_tiempo
   clrf _np_veces
   clrf _np_tiempo1
   clrf _np_tiempo2
   clrf _np_tiempo3
   clrf repetir2
   clrf _np_tmp_var1
   clrf _np_temp8
   clrf _np_temp9
   clrf _np_temp10
   clrf _np_temp11
   clrf _np_temp12
   clrf _np_temp13
   clrf _np_temp14
   clrf _np_temp15
   clrf _np_temp16
   clrf gpio                        ;configurar el puerto a como xxssxsea
   movlw b'00000111'                ;puerto a = e/s digital
   movwf cmcon
   movlw b'00000011'
   bsf status,rp0                   ;cambiar a banco 1
   movwf trisio
   movlw b'00010001'                ;configuracion a/d = ddda
   movwf ansel
   bcf status,rp0                   ;cambiar a banco 0
   bcf adcon0,6                     ;voltaje de referencia vdd

   bsf adcon0,adon                  ;activar activar el mdulo de conv a/d
   bcf gpio,gp2
   bcf gpio,gp4
   bcf gpio,gp5
   clrf control
paso7
   nop

   movf control,w                   ;si el -reg(08), control  = d'0', 
   xorlw d'0'
   btfss status,z
   goto paso7
   btfss adcon0,6                   ;conversin 
   movlw b'10000001'
   btfsc adcon0,6
   movlw b'11000001'
   movwf adcon0
   bcf adcon0,adfm                  ;alinear el resultado a la izquierda
   clrf _np_temp3
   clrf _np_temp4
   movlw .4
   movwf _np_temp5
paso9_ciclos
   movlw .10
   movwf _np_temp1
paso9_t
   decfsz _np_temp1,1
   goto paso9_t
   bsf adcon0,go_done
   nop
   nop
paso9_f
   btfsc adcon0,go_done
   goto paso9_f
   movf adresh,w                    ;recuperar el registro alto de la conversion a/d
   movwf lectura
   addwf _np_temp4,1
   btfsc status,c
   incf _np_temp3,1
   decfsz _np_temp5,1
   goto paso9_ciclos
   bcf status,c
   rrf _np_temp3,1
   rrf _np_temp4,1
   bcf status,c
   rrf _np_temp3,1
   rrf _np_temp4,1
   movf _np_temp4,w
   movwf lectura
   movlw .0
   movwf _np_temp1
   movlw .24
   movwf _np_temp2
   call multi_100_dec               ;llamada a rutina multi_100_dec
   clrf _np_temp1
   movf lectura,w
   movwf _np_temp2
   call multi_16                    ;llamada a rutina multi_16
   movf _np_temp10,w
   movwf _np_temp4
   movf _np_temp11,w
   movwf _np_temp3
   movf _np_temp12,w
   movwf _np_temp2
   movf _np_temp13,w
   movwf _np_temp1
   clrf _np_temp8
   clrf _np_temp7
   clrf _np_temp6
   movlw .100
   movwf _np_temp5
   call division_32                 ;llamada a rutina division_32
   movf _np_temp1,w
   movwf repetir
   movlw .60
   subwf _np_temp1
   btfss status,c
   goto paso10_a
   movlw .60
   movwf repetir
paso10_a
   btfss gpio,gp1                   ;si el -bit, gp1 = 10
   goto paso7
   bsf gpio,gp2
   bsf gpio,gp5
   clrf repetir2
paso15
   incf repetir2,1
   movf repetir,w                   ;temporizador variable
   btfsc status,z
   goto paso16_no
   movwf _np_tmp_var1
paso16_tmp_var
   movlw .1
   call tmp_100_mc                  ;llamada a rutina tmp_100_mc
   decfsz _np_tmp_var1,1
   goto paso16_tmp_var
paso16_no

   movf repetir2,w                  ;si el -reg(08), repetir2  > d'49', 
   sublw d'49'
   btfsc status,c
   goto paso15
   bcf gpio,gp5
   movlw .20                        ;temporizador 200 mse
   call tmp_100_mc                  ;llamada a rutina tmp_100_mc
   bsf gpio,gp4
   movlw d'1'
   movwf control
   goto paso7                       ;cierra el ciclo


;------------------------------------------------------------
;                  Declaracin de Subrutinas
;------------------------------------------------------------

multi_100_dec
   
   bcf status,rp0                   ;cambiar a banco 0
   clrf _np_temp3
   clrf _np_temp4
   movf _np_temp1,w
   movwf _np_temp6
   clrf _np_temp5
   movlw .07
   movwf _np_temp7
   movf _np_temp1,w
   movwf _np_temp13
   movf _np_temp2,w
   movwf _np_temp14
   movf _np_temp3,w
   movwf _np_temp15
multi_100_dec_a
   decfsz _np_temp7,1
   goto multi_100_dec_b
   goto multi_100_dec_d
multi_100_dec_b
   bcf status,c
   rlf _np_temp6,1
   rlf _np_temp5,1
   movf _np_temp7,w
   xorlw .05
   btfsc status,z
   goto multi_100_dec_c
   movf _np_temp7,w
   xorlw .02
   btfsc status,z
   goto multi_100_dec_c
   movf _np_temp7,w
   xorlw .01
   btfss status,z
   goto multi_100_dec_a
multi_100_dec_c
   movf _np_temp6,w
   addwf _np_temp4,1
   btfsc status,c
   incf _np_temp3,1
   movf _np_temp5,w
   addwf _np_temp3,1
   goto multi_100_dec_a
multi_100_dec_d
   movf _np_temp2,w
   addwf _np_temp4,1
   btfsc status,c
   incf _np_temp3,1
   bcf status,rp0                   ;cambiar a banco 0
   return

multi_16
   ;multiplicacion 16 bits x 16 bits = 32 bits
   movlw .16
   bcf status,rp0                   ;cambiar a banco 0
   movwf _np_temp9
   clrf _np_temp10
   clrf _np_temp11
   clrf _np_temp12
   clrf _np_temp13
multi_16_1
   clrf _np_temp5
   clrf _np_temp6
   movf _np_temp1,w
   movwf _np_temp7
   movf _np_temp2,w
   movwf _np_temp8
   decfsz _np_temp9,1
   goto multi_16_2
   rlf _np_temp4,1
   btfsc _np_temp3,7
   call multi_16_5                  ;llamada a rutina multi_16_5
   goto multi_16_8
multi_16_2
   btfss _np_temp3,7
   goto multi_16_4
   movf _np_temp9,w
   movwf _np_temp14
multi_16_3
   bcf status,c
   rlf _np_temp8,1
   rlf _np_temp7,1
   rlf _np_temp6,1
   rlf _np_temp5,1
   decfsz _np_temp14,1
   goto multi_16_3
   call multi_16_5                  ;llamada a rutina multi_16_5
multi_16_4
   bcf status,c
   rlf _np_temp4,1
   rlf _np_temp3,1
   goto multi_16_1
multi_16_5
   movf _np_temp8,w
   addwf _np_temp13,1
   btfsc status,c
   call multi_16_6                  ;llamada a rutina multi_16_6
   movf _np_temp7,w
   addwf _np_temp12,1
   btfsc status,c
   call multi_16_7                  ;llamada a rutina multi_16_7
   movf _np_temp6,w
   addwf _np_temp11,1
   btfsc status,c
   incf _np_temp5,1
   movf _np_temp5,w
   addwf _np_temp10,1
   return
multi_16_6
   incf _np_temp7,1
   btfss status,z
   return
   incf _np_temp6,1
   btfsc status,z
   incf _np_temp5,1
   return
multi_16_7
   incf _np_temp6,1
   btfsc status,z
   incf _np_temp5,1
   return
multi_16_8
   bcf status,rp0                   ;cambiar a banco 0
   return



division_32
   ;division 32 bits / 32 bits
   bcf status,rp0                   ;cambiar a banco 0
   clrf _np_temp14
   clrf _np_temp9
   clrf _np_temp10
   clrf _np_temp11
   clrf _np_temp12
   movlw .32
   movwf _np_temp13
division_32_a
   call division_32_d               ;llamada a rutina division_32_d
   movf _np_temp8,w
   subwf _np_temp12,w
   btfss status,z
   goto division_32_b
   movf _np_temp7,w
   subwf _np_temp11,w
   btfss status,z
   goto division_32_b
   movf _np_temp6,w
   subwf _np_temp10,w
   btfss status,z
   goto division_32_b
   movf _np_temp5,w
   subwf _np_temp9,w
division_32_b
   btfss status,c
   goto division_32_c
   movf _np_temp5,w
   subwf _np_temp9,1
   movf _np_temp6,w
   btfss status,c
   incfsz _np_temp6,w
   subwf _np_temp10,1
   movf _np_temp7,w
   btfss status,c
   incfsz _np_temp7,w
   subwf _np_temp11,1
   movf _np_temp8,w
   btfss status,c
   incfsz _np_temp8,w
   subwf _np_temp12,1
   bcf status,c
   bsf _np_temp1,0
division_32_c
   decfsz _np_temp13,1
   goto division_32_a
   bcf status,rp0                   ;cambiar a banco 0
   return
division_32_d
   rlf _np_temp1,1
   rlf _np_temp2,1
   rlf _np_temp3,1
   rlf _np_temp4,1
   rlf _np_temp9,1
   rlf _np_temp10,1
   rlf _np_temp11,1
   rlf _np_temp12,1
   return

tmp_100_mc
   movwf _np_tiempo
   goto tmp_100_mc_1
tmp_100_mc_bucle2
   nop
   nop
   nop
   nop
   nop
   nop
   nop
tmp_100_mc_1
   movlw .22
   movwf _np_tiempo1
tmp_100_mc_bucle1
   movlw .150
   movwf _np_tiempo2
tmp_100_mc_bucle
   decfsz _np_tiempo2,1
   goto tmp_100_mc_bucle
   decfsz _np_tiempo1,1
   goto tmp_100_mc_bucle1
   nop
   decfsz _np_tiempo,1
   goto tmp_100_mc_bucle2
   return



;------------------------------------------------------------
;                  DATOS EN MEMORIA EEPROM
;------------------------------------------------------------
   org  0x2100
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff

 End